/*
btlock.c Version 0.2.0  Btree lock database
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* return code 0 is good lock */
/* return code 1 is lock status changed */
/* database status was TSTLOCK or NOLOCK. */
/* Status changed to LOCK and the lock has been applied */
/* return code 3 is database locked by another user */
/* return code 4 is lock error */

#include <bthash.h>

int btlock(bthdr)
btreefmt *bthdr;
   {
   int oldlock;
   int lockrslt;
   lockrslt = lockf(bthdr->hndl,F_TEST,0);
   if (lockrslt < 0)
      {
      return(BTLOCK3);
      } /* file is already locked */
   lockrslt = lockf(bthdr->hndl,F_TLOCK,0);
   if (lockrslt < 0)
      {
      fprintf(stderr,"btlock: lock error on %s\n",
	 bthdr->dbname);
      perror("Lock error");
      return(BTLOCK4);
      } /* lock error */
   oldlock = bthdr->lock;
   bthdr->lock = LOCK;
   if (oldlock != LOCK) return(BTLOCK1);
   else return(LOCKGOOD);
   } /* btlock */
