/*
hget.c Version 0.2.0  Hash get record
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

int hget(hshhdr,key,buf)
hashfmt *hshhdr;
unsigned char *key;
unsigned char *buf;
   {
   int rslt;
   off_t ofst;
   unsigned char *p,*q,*r;
   unsigned char *rcdptr;
   hshhdr->reason = 0;
   ofst = (off_t) hash(hshhdr,key);
   hgetblk(hshhdr,ofst);
   if (hshhdr->reason)
      return(HASH_ERR + 2001);
   rcdptr = (unsigned char *) hshhdr->node;
   /* for each record in chain */
   /* including hash data space */
   while (1)
      {
      p = (unsigned char *) rcdptr
	 + hshhdr->rcdhdr + hshhdr->keyofst;
      q = (unsigned char *) p + hshhdr->keylen;
      r = key;
      while (p < q)
	 {
	 rslt = *r - *p;
	 if (rslt) break;
	 p++;
	 r++;
	 } /* for each byte in key */
      if (!rslt)
	 {
	 if (buf != NULL)
	    {
	    p = (unsigned char *) rcdptr + hshhdr->rcdhdr;
	    q = (unsigned char *) p + hshhdr->rcdlen;
	    r = (unsigned char *) buf;
	    while (p < q) *r++ = *p++;
	    } /* if buf specified */
	 return(FOUND);
	 } /* if match */
      else if (hshhdr->node->next != UINT_MAX
         && hshhdr->node->next)
	 {
         hgetblk(hshhdr,hshhdr->node->next);
         if (hshhdr->reason)
            return(HASH_ERR + 2002);
         rcdptr = (unsigned char *) hshhdr->node;
	 continue;
	 } /* if more records on chain */
      else
	 {
         return(NOTFOUND);
	 } /* not found */
      } /* for each record in chain */
   return(HASH_ERR + 2003);
   } /* hget */
